/*
 *  Copyright 2012 The Luvit Authors. All Rights Reserved.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */

#include "lconstants.h"

LUALIB_API int luaopen_constants(lua_State *L) {

#define LUVIT_DEFINE_CONSTANT(constant) \
  lua_pushinteger(L, constant);         \
  lua_setfield(L, -2, #constant)

  lua_newtable (L);

  LUVIT_DEFINE_CONSTANT(AF_UNSPEC);
  LUVIT_DEFINE_CONSTANT(AF_INET);
  LUVIT_DEFINE_CONSTANT(AF_INET6);

  /* file access modes */
  LUVIT_DEFINE_CONSTANT(O_RDONLY);
  LUVIT_DEFINE_CONSTANT(O_WRONLY);
  LUVIT_DEFINE_CONSTANT(O_RDWR);

  LUVIT_DEFINE_CONSTANT(S_IFMT);
  LUVIT_DEFINE_CONSTANT(S_IFREG);
  LUVIT_DEFINE_CONSTANT(S_IFDIR);
  LUVIT_DEFINE_CONSTANT(S_IFCHR);
#ifdef S_IFBLK
  LUVIT_DEFINE_CONSTANT(S_IFBLK);
#endif

#ifdef S_IFIFO
  LUVIT_DEFINE_CONSTANT(S_IFIFO);
#endif

#ifdef S_IFLNK
  LUVIT_DEFINE_CONSTANT(S_IFLNK);
#endif

#ifdef S_IFSOCK
  LUVIT_DEFINE_CONSTANT(S_IFSOCK);
#endif

#ifdef O_CREAT
  LUVIT_DEFINE_CONSTANT(O_CREAT);
#endif

#ifdef O_EXCL
  LUVIT_DEFINE_CONSTANT(O_EXCL);
#endif

#ifdef O_NOCTTY
  LUVIT_DEFINE_CONSTANT(O_NOCTTY);
#endif

#ifdef O_TRUNC
  LUVIT_DEFINE_CONSTANT(O_TRUNC);
#endif

#ifdef O_APPEND
  LUVIT_DEFINE_CONSTANT(O_APPEND);
#endif

#ifdef O_DIRECTORY
  LUVIT_DEFINE_CONSTANT(O_DIRECTORY);
#endif

#ifdef O_EXCL
  LUVIT_DEFINE_CONSTANT(O_EXCL);
#endif

#ifdef O_NOFOLLOW
  LUVIT_DEFINE_CONSTANT(O_NOFOLLOW);
#endif

#ifdef O_SYNC
  LUVIT_DEFINE_CONSTANT(O_SYNC);
#endif

#ifdef O_SYMLINK
  LUVIT_DEFINE_CONSTANT(O_SYMLINK);
#endif


#ifdef S_IRWXU
  LUVIT_DEFINE_CONSTANT(S_IRWXU);
#endif


#ifdef S_IRUSR
  LUVIT_DEFINE_CONSTANT(S_IRUSR);
#endif

#ifdef S_IWUSR
  LUVIT_DEFINE_CONSTANT(S_IWUSR);
#endif

#ifdef S_IXUSR
  LUVIT_DEFINE_CONSTANT(S_IXUSR);
#endif


#ifdef S_IRWXG
  LUVIT_DEFINE_CONSTANT(S_IRWXG);
#endif


#ifdef S_IRGRP
  LUVIT_DEFINE_CONSTANT(S_IRGRP);
#endif

#ifdef S_IWGRP
  LUVIT_DEFINE_CONSTANT(S_IWGRP);
#endif

#ifdef S_IXGRP
  LUVIT_DEFINE_CONSTANT(S_IXGRP);
#endif


#ifdef S_IRWXO
  LUVIT_DEFINE_CONSTANT(S_IRWXO);
#endif


#ifdef S_IROTH
  LUVIT_DEFINE_CONSTANT(S_IROTH);
#endif

#ifdef S_IWOTH
  LUVIT_DEFINE_CONSTANT(S_IWOTH);
#endif

#ifdef S_IXOTH
  LUVIT_DEFINE_CONSTANT(S_IXOTH);
#endif

#ifdef E2BIG
  LUVIT_DEFINE_CONSTANT(E2BIG);
#endif

#ifdef EACCES
  LUVIT_DEFINE_CONSTANT(EACCES);
#endif

#ifdef EADDRINUSE
  LUVIT_DEFINE_CONSTANT(EADDRINUSE);
#endif

#ifdef EADDRNOTAVAIL
  LUVIT_DEFINE_CONSTANT(EADDRNOTAVAIL);
#endif

#ifdef EAFNOSUPPORT
  LUVIT_DEFINE_CONSTANT(EAFNOSUPPORT);
#endif

#ifdef EAGAIN
  LUVIT_DEFINE_CONSTANT(EAGAIN);
#endif

#ifdef EALREADY
  LUVIT_DEFINE_CONSTANT(EALREADY);
#endif

#ifdef EBADF
  LUVIT_DEFINE_CONSTANT(EBADF);
#endif

#ifdef EBADMSG
  LUVIT_DEFINE_CONSTANT(EBADMSG);
#endif

#ifdef EBUSY
  LUVIT_DEFINE_CONSTANT(EBUSY);
#endif

#ifdef ECANCELED
  LUVIT_DEFINE_CONSTANT(ECANCELED);
#endif

#ifdef ECHILD
  LUVIT_DEFINE_CONSTANT(ECHILD);
#endif

#ifdef ECONNABORTED
  LUVIT_DEFINE_CONSTANT(ECONNABORTED);
#endif

#ifdef ECONNREFUSED
  LUVIT_DEFINE_CONSTANT(ECONNREFUSED);
#endif

#ifdef ECONNRESET
  LUVIT_DEFINE_CONSTANT(ECONNRESET);
#endif

#ifdef EDEADLK
  LUVIT_DEFINE_CONSTANT(EDEADLK);
#endif

#ifdef EDESTADDRREQ
  LUVIT_DEFINE_CONSTANT(EDESTADDRREQ);
#endif

#ifdef EDOM
  LUVIT_DEFINE_CONSTANT(EDOM);
#endif

#ifdef EDQUOT
  LUVIT_DEFINE_CONSTANT(EDQUOT);
#endif

#ifdef EEXIST
  LUVIT_DEFINE_CONSTANT(EEXIST);
#endif

#ifdef EFAULT
  LUVIT_DEFINE_CONSTANT(EFAULT);
#endif

#ifdef EFBIG
  LUVIT_DEFINE_CONSTANT(EFBIG);
#endif

#ifdef EHOSTUNREACH
  LUVIT_DEFINE_CONSTANT(EHOSTUNREACH);
#endif

#ifdef EIDRM
  LUVIT_DEFINE_CONSTANT(EIDRM);
#endif

#ifdef EILSEQ
  LUVIT_DEFINE_CONSTANT(EILSEQ);
#endif

#ifdef EINPROGRESS
  LUVIT_DEFINE_CONSTANT(EINPROGRESS);
#endif

#ifdef EINTR
  LUVIT_DEFINE_CONSTANT(EINTR);
#endif

#ifdef EINVAL
  LUVIT_DEFINE_CONSTANT(EINVAL);
#endif

#ifdef EIO
  LUVIT_DEFINE_CONSTANT(EIO);
#endif

#ifdef EISCONN
  LUVIT_DEFINE_CONSTANT(EISCONN);
#endif

#ifdef EISDIR
  LUVIT_DEFINE_CONSTANT(EISDIR);
#endif

#ifdef ELOOP
  LUVIT_DEFINE_CONSTANT(ELOOP);
#endif

#ifdef EMFILE
  LUVIT_DEFINE_CONSTANT(EMFILE);
#endif

#ifdef EMLINK
  LUVIT_DEFINE_CONSTANT(EMLINK);
#endif

#ifdef EMSGSIZE
  LUVIT_DEFINE_CONSTANT(EMSGSIZE);
#endif

#ifdef EMULTIHOP
  LUVIT_DEFINE_CONSTANT(EMULTIHOP);
#endif

#ifdef ENAMETOOLONG
  LUVIT_DEFINE_CONSTANT(ENAMETOOLONG);
#endif

#ifdef ENETDOWN
  LUVIT_DEFINE_CONSTANT(ENETDOWN);
#endif

#ifdef ENETRESET
  LUVIT_DEFINE_CONSTANT(ENETRESET);
#endif

#ifdef ENETUNREACH
  LUVIT_DEFINE_CONSTANT(ENETUNREACH);
#endif

#ifdef ENFILE
  LUVIT_DEFINE_CONSTANT(ENFILE);
#endif

#ifdef ENOBUFS
  LUVIT_DEFINE_CONSTANT(ENOBUFS);
#endif

#ifdef ENODATA
  LUVIT_DEFINE_CONSTANT(ENODATA);
#endif

#ifdef ENODEV
  LUVIT_DEFINE_CONSTANT(ENODEV);
#endif

#ifdef ENOENT
  LUVIT_DEFINE_CONSTANT(ENOENT);
#endif

#ifdef ENOEXEC
  LUVIT_DEFINE_CONSTANT(ENOEXEC);
#endif

#ifdef ENOLCK
  LUVIT_DEFINE_CONSTANT(ENOLCK);
#endif

#ifdef ENOLINK
  LUVIT_DEFINE_CONSTANT(ENOLINK);
#endif

#ifdef ENOMEM
  LUVIT_DEFINE_CONSTANT(ENOMEM);
#endif

#ifdef ENOMSG
  LUVIT_DEFINE_CONSTANT(ENOMSG);
#endif

#ifdef ENOPROTOOPT
  LUVIT_DEFINE_CONSTANT(ENOPROTOOPT);
#endif

#ifdef ENOSPC
  LUVIT_DEFINE_CONSTANT(ENOSPC);
#endif

#ifdef ENOSR
  LUVIT_DEFINE_CONSTANT(ENOSR);
#endif

#ifdef ENOSTR
  LUVIT_DEFINE_CONSTANT(ENOSTR);
#endif

#ifdef ENOSYS
  LUVIT_DEFINE_CONSTANT(ENOSYS);
#endif

#ifdef ENOTCONN
  LUVIT_DEFINE_CONSTANT(ENOTCONN);
#endif

#ifdef ENOTDIR
  LUVIT_DEFINE_CONSTANT(ENOTDIR);
#endif

#ifdef ENOTEMPTY
  LUVIT_DEFINE_CONSTANT(ENOTEMPTY);
#endif

#ifdef ENOTSOCK
  LUVIT_DEFINE_CONSTANT(ENOTSOCK);
#endif

#ifdef ENOTSUP
  LUVIT_DEFINE_CONSTANT(ENOTSUP);
#endif

#ifdef ENOTTY
  LUVIT_DEFINE_CONSTANT(ENOTTY);
#endif

#ifdef ENXIO
  LUVIT_DEFINE_CONSTANT(ENXIO);
#endif

#ifdef EOPNOTSUPP
  LUVIT_DEFINE_CONSTANT(EOPNOTSUPP);
#endif

#ifdef EOVERFLOW
  LUVIT_DEFINE_CONSTANT(EOVERFLOW);
#endif

#ifdef EPERM
  LUVIT_DEFINE_CONSTANT(EPERM);
#endif

#ifdef EPIPE
  LUVIT_DEFINE_CONSTANT(EPIPE);
#endif

#ifdef EPROTO
  LUVIT_DEFINE_CONSTANT(EPROTO);
#endif

#ifdef EPROTONOSUPPORT
  LUVIT_DEFINE_CONSTANT(EPROTONOSUPPORT);
#endif

#ifdef EPROTOTYPE
  LUVIT_DEFINE_CONSTANT(EPROTOTYPE);
#endif

#ifdef ERANGE
  LUVIT_DEFINE_CONSTANT(ERANGE);
#endif

#ifdef EROFS
  LUVIT_DEFINE_CONSTANT(EROFS);
#endif

#ifdef ESPIPE
  LUVIT_DEFINE_CONSTANT(ESPIPE);
#endif

#ifdef ESRCH
  LUVIT_DEFINE_CONSTANT(ESRCH);
#endif

#ifdef ESTALE
  LUVIT_DEFINE_CONSTANT(ESTALE);
#endif

#ifdef ETIME
  LUVIT_DEFINE_CONSTANT(ETIME);
#endif

#ifdef ETIMEDOUT
  LUVIT_DEFINE_CONSTANT(ETIMEDOUT);
#endif

#ifdef ETXTBSY
  LUVIT_DEFINE_CONSTANT(ETXTBSY);
#endif

#ifdef EWOULDBLOCK
  LUVIT_DEFINE_CONSTANT(EWOULDBLOCK);
#endif

#ifdef EXDEV
  LUVIT_DEFINE_CONSTANT(EXDEV);
#endif

#ifdef WSAEINTR
  LUVIT_DEFINE_CONSTANT(WSAEINTR);
#endif

#ifdef WSAEBADF
  LUVIT_DEFINE_CONSTANT(WSAEBADF);
#endif

#ifdef WSAEACCES
  LUVIT_DEFINE_CONSTANT(WSAEACCES);
#endif

#ifdef WSAEFAULT
  LUVIT_DEFINE_CONSTANT(WSAEFAULT);
#endif

#ifdef WSAEINVAL
  LUVIT_DEFINE_CONSTANT(WSAEINVAL);
#endif

#ifdef WSAEMFILE
  LUVIT_DEFINE_CONSTANT(WSAEMFILE);
#endif

#ifdef WSAEWOULDBLOCK
  LUVIT_DEFINE_CONSTANT(WSAEWOULDBLOCK);
#endif

#ifdef WSAEINPROGRESS
  LUVIT_DEFINE_CONSTANT(WSAEINPROGRESS);
#endif

#ifdef WSAEALREADY
  LUVIT_DEFINE_CONSTANT(WSAEALREADY);
#endif

#ifdef WSAENOTSOCK
  LUVIT_DEFINE_CONSTANT(WSAENOTSOCK);
#endif

#ifdef WSAEDESTADDRREQ
  LUVIT_DEFINE_CONSTANT(WSAEDESTADDRREQ);
#endif

#ifdef WSAEMSGSIZE
  LUVIT_DEFINE_CONSTANT(WSAEMSGSIZE);
#endif

#ifdef WSAEPROTOTYPE
  LUVIT_DEFINE_CONSTANT(WSAEPROTOTYPE);
#endif

#ifdef WSAENOPROTOOPT
  LUVIT_DEFINE_CONSTANT(WSAENOPROTOOPT);
#endif

#ifdef WSAEPROTONOSUPPORT
  LUVIT_DEFINE_CONSTANT(WSAEPROTONOSUPPORT);
#endif

#ifdef WSAESOCKTNOSUPPORT
  LUVIT_DEFINE_CONSTANT(WSAESOCKTNOSUPPORT);
#endif

#ifdef WSAEOPNOTSUPP
  LUVIT_DEFINE_CONSTANT(WSAEOPNOTSUPP);
#endif

#ifdef WSAEPFNOSUPPORT
  LUVIT_DEFINE_CONSTANT(WSAEPFNOSUPPORT);
#endif

#ifdef WSAEAFNOSUPPORT
  LUVIT_DEFINE_CONSTANT(WSAEAFNOSUPPORT);
#endif

#ifdef WSAEADDRINUSE
  LUVIT_DEFINE_CONSTANT(WSAEADDRINUSE);
#endif

#ifdef WSAEADDRNOTAVAIL
  LUVIT_DEFINE_CONSTANT(WSAEADDRNOTAVAIL);
#endif

#ifdef WSAENETDOWN
  LUVIT_DEFINE_CONSTANT(WSAENETDOWN);
#endif

#ifdef WSAENETUNREACH
  LUVIT_DEFINE_CONSTANT(WSAENETUNREACH);
#endif

#ifdef WSAENETRESET
  LUVIT_DEFINE_CONSTANT(WSAENETRESET);
#endif

#ifdef WSAECONNABORTED
  LUVIT_DEFINE_CONSTANT(WSAECONNABORTED);
#endif

#ifdef WSAECONNRESET
  LUVIT_DEFINE_CONSTANT(WSAECONNRESET);
#endif

#ifdef WSAENOBUFS
  LUVIT_DEFINE_CONSTANT(WSAENOBUFS);
#endif

#ifdef WSAEISCONN
  LUVIT_DEFINE_CONSTANT(WSAEISCONN);
#endif

#ifdef WSAENOTCONN
  LUVIT_DEFINE_CONSTANT(WSAENOTCONN);
#endif

#ifdef WSAESHUTDOWN
  LUVIT_DEFINE_CONSTANT(WSAESHUTDOWN);
#endif

#ifdef WSAETOOMANYREFS
  LUVIT_DEFINE_CONSTANT(WSAETOOMANYREFS);
#endif

#ifdef WSAETIMEDOUT
  LUVIT_DEFINE_CONSTANT(WSAETIMEDOUT);
#endif

#ifdef WSAECONNREFUSED
  LUVIT_DEFINE_CONSTANT(WSAECONNREFUSED);
#endif

#ifdef WSAELOOP
  LUVIT_DEFINE_CONSTANT(WSAELOOP);
#endif

#ifdef WSAENAMETOOLONG
  LUVIT_DEFINE_CONSTANT(WSAENAMETOOLONG);
#endif

#ifdef WSAEHOSTDOWN
  LUVIT_DEFINE_CONSTANT(WSAEHOSTDOWN);
#endif

#ifdef WSAEHOSTUNREACH
  LUVIT_DEFINE_CONSTANT(WSAEHOSTUNREACH);
#endif

#ifdef WSAENOTEMPTY
  LUVIT_DEFINE_CONSTANT(WSAENOTEMPTY);
#endif

#ifdef WSAEPROCLIM
  LUVIT_DEFINE_CONSTANT(WSAEPROCLIM);
#endif

#ifdef WSAEUSERS
  LUVIT_DEFINE_CONSTANT(WSAEUSERS);
#endif

#ifdef WSAEDQUOT
  LUVIT_DEFINE_CONSTANT(WSAEDQUOT);
#endif

#ifdef WSAESTALE
  LUVIT_DEFINE_CONSTANT(WSAESTALE);
#endif

#ifdef WSAEREMOTE
  LUVIT_DEFINE_CONSTANT(WSAEREMOTE);
#endif

#ifdef WSASYSNOTREADY
  LUVIT_DEFINE_CONSTANT(WSASYSNOTREADY);
#endif

#ifdef WSAVERNOTSUPPORTED
  LUVIT_DEFINE_CONSTANT(WSAVERNOTSUPPORTED);
#endif

#ifdef WSANOTINITIALISED
  LUVIT_DEFINE_CONSTANT(WSANOTINITIALISED);
#endif

#ifdef WSAEDISCON
  LUVIT_DEFINE_CONSTANT(WSAEDISCON);
#endif

#ifdef WSAENOMORE
  LUVIT_DEFINE_CONSTANT(WSAENOMORE);
#endif

#ifdef WSAECANCELLED
  LUVIT_DEFINE_CONSTANT(WSAECANCELLED);
#endif

#ifdef WSAEINVALIDPROCTABLE
  LUVIT_DEFINE_CONSTANT(WSAEINVALIDPROCTABLE);
#endif

#ifdef WSAEINVALIDPROVIDER
  LUVIT_DEFINE_CONSTANT(WSAEINVALIDPROVIDER);
#endif

#ifdef WSAEPROVIDERFAILEDINIT
  LUVIT_DEFINE_CONSTANT(WSAEPROVIDERFAILEDINIT);
#endif

#ifdef WSASYSCALLFAILURE
  LUVIT_DEFINE_CONSTANT(WSASYSCALLFAILURE);
#endif

#ifdef WSASERVICE_NOT_FOUND
  LUVIT_DEFINE_CONSTANT(WSASERVICE_NOT_FOUND);
#endif

#ifdef WSATYPE_NOT_FOUND
  LUVIT_DEFINE_CONSTANT(WSATYPE_NOT_FOUND);
#endif

#ifdef WSA_E_NO_MORE
  LUVIT_DEFINE_CONSTANT(WSA_E_NO_MORE);
#endif

#ifdef WSA_E_CANCELLED
  LUVIT_DEFINE_CONSTANT(WSA_E_CANCELLED);
#endif

#ifdef WSAEREFUSED
  LUVIT_DEFINE_CONSTANT(WSAEREFUSED);
#endif

#ifdef SIGHUP
  LUVIT_DEFINE_CONSTANT(SIGHUP);
#endif

#ifdef SIGINT
  LUVIT_DEFINE_CONSTANT(SIGINT);
#endif

#ifdef SIGQUIT
  LUVIT_DEFINE_CONSTANT(SIGQUIT);
#endif

#ifdef SIGILL
  LUVIT_DEFINE_CONSTANT(SIGILL);
#endif

#ifdef SIGTRAP
  LUVIT_DEFINE_CONSTANT(SIGTRAP);
#endif

#ifdef SIGABRT
  LUVIT_DEFINE_CONSTANT(SIGABRT);
#endif

#ifdef SIGIOT
  LUVIT_DEFINE_CONSTANT(SIGIOT);
#endif

#ifdef SIGBUS
  LUVIT_DEFINE_CONSTANT(SIGBUS);
#endif

#ifdef SIGFPE
  LUVIT_DEFINE_CONSTANT(SIGFPE);
#endif

#ifdef SIGKILL
  LUVIT_DEFINE_CONSTANT(SIGKILL);
#endif

#ifdef SIGUSR1
  LUVIT_DEFINE_CONSTANT(SIGUSR1);
#endif

#ifdef SIGSEGV
  LUVIT_DEFINE_CONSTANT(SIGSEGV);
#endif

#ifdef SIGUSR2
  LUVIT_DEFINE_CONSTANT(SIGUSR2);
#endif

#ifdef SIGPIPE
  LUVIT_DEFINE_CONSTANT(SIGPIPE);
#endif

#ifdef SIGALRM
  LUVIT_DEFINE_CONSTANT(SIGALRM);
#endif

  LUVIT_DEFINE_CONSTANT(SIGTERM);

#ifdef SIGCHLD
  LUVIT_DEFINE_CONSTANT(SIGCHLD);
#endif

#ifdef SIGSTKFLT
  LUVIT_DEFINE_CONSTANT(SIGSTKFLT);
#endif


#ifdef SIGCONT
  LUVIT_DEFINE_CONSTANT(SIGCONT);
#endif

#ifdef SIGSTOP
  LUVIT_DEFINE_CONSTANT(SIGSTOP);
#endif

#ifdef SIGTSTP
  LUVIT_DEFINE_CONSTANT(SIGTSTP);
#endif

#ifdef SIGTTIN
  LUVIT_DEFINE_CONSTANT(SIGTTIN);
#endif

#ifdef SIGTTOU
  LUVIT_DEFINE_CONSTANT(SIGTTOU);
#endif

#ifdef SIGURG
  LUVIT_DEFINE_CONSTANT(SIGURG);
#endif

#ifdef SIGXCPU
  LUVIT_DEFINE_CONSTANT(SIGXCPU);
#endif

#ifdef SIGXFSZ
  LUVIT_DEFINE_CONSTANT(SIGXFSZ);
#endif

#ifdef SIGVTALRM
  LUVIT_DEFINE_CONSTANT(SIGVTALRM);
#endif

#ifdef SIGPROF
  LUVIT_DEFINE_CONSTANT(SIGPROF);
#endif

#ifdef SIGWINCH
  LUVIT_DEFINE_CONSTANT(SIGWINCH);
#endif

#ifdef SIGIO
  LUVIT_DEFINE_CONSTANT(SIGIO);
#endif

#ifdef SIGPOLL
  LUVIT_DEFINE_CONSTANT(SIGPOLL);
#endif

#ifdef SIGLOST
  LUVIT_DEFINE_CONSTANT(SIGLOST);
#endif

#ifdef SIGPWR
  LUVIT_DEFINE_CONSTANT(SIGPWR);
#endif

#ifdef SIGSYS
  LUVIT_DEFINE_CONSTANT(SIGSYS);
#endif

#ifdef SIGUNUSED
  LUVIT_DEFINE_CONSTANT(SIGUNUSED);
#endif

/* OpenSSL SSL context options */

#ifdef SSL_OP_NO_QUERY_MTU
  LUVIT_DEFINE_CONSTANT(SSL_OP_NO_QUERY_MTU);
#endif

#ifdef SSL_OP_COOKIE_EXCHANGE
  LUVIT_DEFINE_CONSTANT(SSL_OP_COOKIE_EXCHANGE);
#endif

#ifdef SSL_OP_NO_TICKET
  LUVIT_DEFINE_CONSTANT(SSL_OP_NO_TICKET);
#endif

#ifdef SSL_OP_NO_SESSION_RESUMPTION_ON_RENEGOTIATION
  LUVIT_DEFINE_CONSTANT(SSL_OP_NO_SESSION_RESUMPTION_ON_RENEGOTIATION);
#endif

#ifdef SSL_OP_SINGLE_ECDH_USE
  LUVIT_DEFINE_CONSTANT(SSL_OP_SINGLE_ECDH_USE);
#endif

#ifdef SSL_OP_SINGLE_DH_USE
  LUVIT_DEFINE_CONSTANT(SSL_OP_SINGLE_DH_USE);
#endif

#ifdef SSL_OP_EPHEMERAL_RSA
  LUVIT_DEFINE_CONSTANT(SSL_OP_EPHEMERAL_RSA);
#endif

#ifdef SSL_OP_CIPHER_SERVER_PREFERENCE
  LUVIT_DEFINE_CONSTANT(SSL_OP_CIPHER_SERVER_PREFERENCE);
#endif

#ifdef SSL_OP_TLS_ROLLBACK_BUG
  LUVIT_DEFINE_CONSTANT(SSL_OP_TLS_ROLLBACK_BUG);
#endif

#ifdef SSL_OP_NO_SSLv2
  LUVIT_DEFINE_CONSTANT(SSL_OP_NO_SSLv2);
#endif

#ifdef SSL_OP_NO_SSLv3
  LUVIT_DEFINE_CONSTANT(SSL_OP_NO_SSLv3);
#endif

#ifdef SSL_OP_NO_TLSv1
  LUVIT_DEFINE_CONSTANT(SSL_OP_NO_TLSv1);
#endif

#ifdef SSL_OP_PKCS1_CHECK_1
  LUVIT_DEFINE_CONSTANT(SSL_OP_PKCS1_CHECK_1);
#endif

#ifdef SSL_OP_PKCS1_CHECK_2
  LUVIT_DEFINE_CONSTANT(SSL_OP_PKCS1_CHECK_2);
#endif

#ifdef SSL_OP_NETSCAPE_CA_DN_BUG
  LUVIT_DEFINE_CONSTANT(SSL_OP_NETSCAPE_CA_DN_BUG);
#endif

#ifdef SSL_OP_NETSCAPE_DEMO_CIPHER_CHANGE_BUG
  LUVIT_DEFINE_CONSTANT(SSL_OP_NETSCAPE_DEMO_CIPHER_CHANGE_BUG);
#endif

#ifdef SSL_OP_CRYPTOPRO_TLSEXT_BUG
  LUVIT_DEFINE_CONSTANT(SSL_OP_CRYPTOPRO_TLSEXT_BUG);
#endif

#ifdef OPENSSL_NPN_NEGOTIATED
#define NPN_ENABLED 1
  LUVIT_DEFINE_CONSTANT(NPN_ENABLED);
#endif

  return 1;
}

